VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFFFF&
   Caption         =   "Working with Labels and Text"
   ClientHeight    =   3705
   ClientLeft      =   165
   ClientTop       =   3300
   ClientWidth     =   3885
   LinkTopic       =   "Form1"
   ScaleHeight     =   3705
   ScaleWidth      =   3885
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   500
      Left            =   120
      Top             =   120
   End
   Begin VB.CheckBox Check2 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Clear Text"
      Height          =   255
      Left            =   480
      TabIndex        =   5
      Top             =   1800
      Width           =   1815
   End
   Begin VB.CheckBox Check1 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Slanted Shadow"
      Height          =   255
      Left            =   480
      TabIndex        =   4
      Top             =   1560
      Value           =   1  'Checked
      Width           =   1575
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      Left            =   840
      Max             =   100
      Min             =   -100
      TabIndex        =   3
      Top             =   2160
      Value           =   20
      Width           =   1815
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   1695
      Left            =   3480
      Max             =   200
      Min             =   -200
      TabIndex        =   2
      Top             =   360
      Value           =   20
      Width           =   255
   End
   Begin VB.Label lblMarquee 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      BeginProperty Font 
         Name            =   "Comic Sans MS"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C00000&
      Height          =   495
      Left            =   1200
      TabIndex        =   6
      Top             =   2880
      Width           =   105
   End
   Begin VB.Label lbltext 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Color"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   24
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000080&
      Height          =   540
      Index           =   0
      Left            =   570
      TabIndex        =   0
      Top             =   480
      Width           =   2235
      WordWrap        =   -1  'True
   End
   Begin VB.Label lbltext 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Color"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   24
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00808080&
      Height          =   555
      Index           =   1
      Left            =   570
      TabIndex        =   1
      Top             =   360
      Width           =   2235
      WordWrap        =   -1  'True
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileSub 
         Caption         =   "&Change Scroll message"
         Index           =   0
      End
      Begin VB.Menu mnuFileSub 
         Caption         =   "&Print"
         Index           =   1
      End
      Begin VB.Menu mnuFileSub 
         Caption         =   "E&xit"
         Index           =   2
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*Begin Description
'This code shows a few simple examples of how to use labels to
'spruce up your apps by creating text shadowing and using scroll
'bars to adjusting the shadowing depth and angle for different
'effects. Type in and print the text. Also how to create a simple
'scrolling marquee that you can use a number of ways such as
'displaying titles, help messages, message of the day, bulletins etc.
'Labels use fewer system resources, allow transparency
'Labels do not have keypress events so the keystrokes must be
'captured by another event as shown. An input box is used to
'change the scroll bar text. Notice how when the help message box
'is displayed the scrolling text stops. This is a sample of how
'a modal window stops your code until you click OK and release it.
'*End Description
'*Begin Keywords
'Label,Scroll Bar,Keypress,Keyascii,Object,Top,Left,printflag
'CurrentX,CurrentY,FontName,FontSize,ForeColor,FontItalic,Cls
'Checkbox,Chr(KeyAscii),Chr(),Setfocus,Mid(),Set,Alignment
'*End Keywords
'*Begin Topics
'ScrollBar Values, Creating Marquees from labels, Text Shadowing
'Text in labels, Creating Special Effects
'*End Topics
Option Explicit
Dim HorizOffset As Integer, VertOffset As Integer, PrtObj As Object
Dim TextForLabels As String, TextForMarquee As String, Marqueemax As Integer
Dim MarqueeText As String, MarqueeLength As Integer, SPoint As Integer
Dim PrintFlag As Boolean, TempText As String

Private Sub PrintOffset()
    Form1.Cls
    'Position the labels at the offsets set
    lbltext(1).Top = lbltext(0).Top + VertOffset
    lbltext(1).Left = lbltext(0).Left + HorizOffset
    'If printing to printer
    If PrintFlag = True Then
        'Set the print font properties of the print object
        PrtObj.FontName = lbltext(1).FontName
        PrtObj.FontSize = lbltext(1).FontSize
        PrtObj.ForeColor = lbltext(1).ForeColor
        'Set the print positions on the print object to correspond
        'to the label positions
        PrtObj.CurrentX = lbltext(1).Left
        PrtObj.CurrentY = lbltext(1).Top
        'print the text
        PrtObj.Print lbltext(1)
        'Check and set the printer to italic
        If lbltext(0).FontItalic Then PrtObj.FontItalic = True
        PrtObj.ForeColor = lbltext(0).ForeColor
        'Set the print position on the print object to correspond
        'to the label positions
        PrtObj.CurrentX = lbltext(0).Left
        PrtObj.CurrentY = lbltext(0).Top
        PrtObj.Print lbltext(0)
        'If the print object font italic is on then turn it off
        If PrtObj.FontItalic Then PrtObj.FontItalic = Not PrtObj.FontItalic
    End If
    PrtObj.CurrentY = 0
    PrtObj.Print "Vertical offset = " & VertOffset & " - Horizontal offset = " & HorizOffset
    Form1.SetFocus
End Sub

Private Sub Check1_Click()
    'creates slanted text by making the back label foont italic
    lbltext(1).FontItalic = Not lbltext(1).FontItalic
    'returns the focus to the form for keypress events
    Form1.SetFocus
End Sub

Private Sub Check2_Click()
    'clear the form
    Form1.Cls
    'uncheck box
    Check2.Value = 0
    lbltext(0).Caption = ""
    lbltext(1).Caption = ""
    'returns the focus to the form for keypress events
    Form1.SetFocus
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
    'adds the key pressed character to the string
    TextForLabels = TextForLabels & Chr(KeyAscii)
    'puts it in the labels captions
    lbltext(0).Caption = TextForLabels
    lbltext(1).Caption = TextForLabels
    'Set the off set and prints it
    PrintOffset
End Sub

Private Sub Form_Load()
    PrintFlag = False
    VertOffset = 20
    HorizOffset = 20
    'The length of the marquee in characters
    Marqueemax = 12
    'Starting number of characters displayed in the marquee
    MarqueeLength = 1
    'Starting position of the mid function
    SPoint = 1
    'Set the print object to the form
    Set PrtObj = Form1
    'store the string to be displayed in the marquee
    TextForMarquee = "This text will continue wrapping with this message"
    'store the characters actually displayed in the marquee label
    MarqueeText = Left(TextForMarquee, MarqueeLength)
    'put the text in the marquee label caption
    lblMarquee.Caption = MarqueeText
End Sub

Private Sub HScroll1_Change()
    'change the horizontal offset variable to the horizontal
    'scroll bar value. The size of the change depends on the
    'scroll bar properties: smallchange and largechange
    HorizOffset = HScroll1.Value
    'print the shadow label captions
    PrintOffset
End Sub

Private Sub HScroll1_KeyPress(KeyAscii As Integer)
    'If the scroll bar has focus when a key is pressed sent
    'the user to form key press event
    Form_KeyPress KeyAscii
End Sub

Private Sub HScroll1_Scroll()
    'This event is triggered by dragging the horizontal bar
    'it calls the change event
    HScroll1_Change
End Sub

Private Sub mnufilesub_Click(Index As Integer)
    Select Case Index
        Case 0
            'Display input box
            TempText = InputBox("Input new scroll text", "Scroll Text", TextForMarquee)
            'if data was input then reset variables
            If Len(TempText) > 0 Then
                TextForMarquee = TempText
                lblMarquee = ""
                MarqueeLength = 1
                SPoint = 0
                lblMarquee.Alignment = 2
                lblMarquee.Left = 1200
                'MarqueeText = Mid(TextForMarquee, SPoint, MarqueeLength)
            End If
        Case 1
            'print from the file menu
            Set PrtObj = Printer
            'Turns the print flag on
            PrintFlag = True
            'Hide the labels
            lbltext(1).Visible = False
            lbltext(0).Visible = False
            'Positions and prints
            PrintOffset
            PrtObj.EndDoc
            Set PrtObj = Form1
            'reshow the labels
            lbltext(1).Visible = True
            lbltext(0).Visible = True
        Case 2
            'Release the object
            Set PrtObj = Nothing
            'Exit the app
            End
    End Select
End Sub

Private Sub mnuHelp_Click()
    'Help Message box
    MsgBox "Type in some new text." & vbCr & "Adjust the text shadow by clicking " & vbCr _
    & "or dragging the horizontal and vertical scroll bars." & vbCr _
    & "Print the text by selecting the print from the file menu. " & vbCr _
    & "Input new Scrolling text from the file menu." & vbCr _
    & "Questions or comments contact:" & vbCr & Space(5) & "Ethan Miller, Customized Software" & vbCr & Space(5) & "Phone 605-2705" & vbCr _
    & Space(5) & "Email - millerf@pa.net", , "Working with Labels"
    
End Sub
'Timer event creates the label marquee scrolling
Private Sub Timer1_Timer()
    'initial load causes the scroll to to start at one character
    'and add till the marqueemax is reached
  
    If Len(MarqueeText) < Marqueemax And Len(TextForMarquee) - SPoint > Marqueemax Then
        If SPoint = 0 Then SPoint = 1
        MarqueeText = Mid(TextForMarquee, SPoint, MarqueeLength)
        If MarqueeLength < Marqueemax Then MarqueeLength = MarqueeLength + 1
        lblMarquee.Caption = MarqueeText
    Else
        'Once the marqueemax is reached the starting point for the
        'mid function extraction is Incremented
 SPoint = SPoint + 1
        'left justify the text
        lblMarquee.Alignment = 0
        'Extract the current text to display
        MarqueeText = Mid(TextForMarquee, SPoint, Marqueemax)
        'Display extracted text
        lblMarquee.Caption = MarqueeText
        'Text reached the end so reset variables and display text
        If SPoint = Len(TextForMarquee) + 1 Then
            lblMarquee = ""
            MarqueeLength = 1
        
            'center justify
            lblMarquee.Alignment = 2
            lblMarquee.Left = 1200
            'MarqueeText = Mid(TextForMarquee, SPoint, MarqueeLength)
            SPoint = 0
        End If
               
    End If
    
End Sub

Private Sub VScroll1_Change()
    'change the Vertical offset variable to the Vertical
    'scroll bar value. The size of the change depends on the
    'scroll bar properties: smallchange and largechange
    VertOffset = VScroll1.Value
    'print the shadow label captions
    PrintOffset
End Sub

Private Sub VScroll1_KeyPress(KeyAscii As Integer)
    'If the scroll bar has focus when a key is pressed sent
    'the user to form key press event
    Form_KeyPress KeyAscii
End Sub

Private Sub VScroll1_Scroll()
    'This event is triggered by dragging the horizontal bar
    'it calls the change event
    VScroll1_Change
End Sub
